> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://docs.nvidia.com/infra-controller/llms.txt.
> For full documentation content, see https://docs.nvidia.com/infra-controller/llms-full.txt.

# Create Expected Switch

POST https://carbide-rest-api.carbide.svc.cluster.local/v2/org/{org}/carbide/expected-switch
Content-Type: application/json

Create an Expected Switch to pre-register network switches expected to be discovered at a Site.

Org must have an Infrastructure Provider entity. User must have `FORGE_PROVIDER_ADMIN` role.

Alternatively, Tenant Admins with `TargetedInstanceCreation` capability can also create Expected Switches if they have an account with the Site's Infrastructure Provider.

Reference: https://docs.nvidia.com/infra-controller/infra-controller/rest-api-reference/api-reference/expected-switch/create-expected-switch

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: NCX Infra Controller REST API
  version: 1.0.0
paths:
  /v2/org/{org}/carbide/expected-switch:
    post:
      operationId: create-expected-switch
      summary: Create Expected Switch
      description: >-
        Create an Expected Switch to pre-register network switches expected to
        be discovered at a Site.


        Org must have an Infrastructure Provider entity. User must have
        `FORGE_PROVIDER_ADMIN` role.


        Alternatively, Tenant Admins with `TargetedInstanceCreation` capability
        can also create Expected Switches if they have an account with the
        Site's Infrastructure Provider.
      tags:
        - subpackage_expectedSwitch
      parameters:
        - name: org
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: >-
            ```

            export JWT_BEARER_TOKEN="<jwt-bearer-token>"


            # Example org name: "acme-inc

            export ORG_NAME=<org-name>


            # Use the JWT bearer token in your API request auth header:

            curl -v -X GET -H "Content-Type: application/json" -H
            "Authorization: Bearer $JWT_BEARER_TOKEN"
            https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

            ```
          required: true
          schema:
            type: string
      responses:
        '201':
          description: Created
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ExpectedSwitch'
        '400':
          description: Error response when request data cannot be validated
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
        '403':
          description: >-
            Error response when user is not authorized to call an endpoint or
            retrieve/modify objects
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CarbideAPIError'
      requestBody:
        description: Expected Switch creation request
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/ExpectedSwitchCreateRequest'
servers:
  - url: https://carbide-rest-api.carbide.svc.cluster.local
components:
  schemas:
    Labels:
      type: object
      additionalProperties:
        type: string
      title: Labels
    ExpectedSwitchCreateRequest:
      type: object
      properties:
        siteId:
          type: string
          format: uuid
          description: ID of the site the Expected Switch belongs to
        bmcMacAddress:
          type: string
          description: >-
            MAC address of the Expected Switch's BMC (Baseboard Management
            Controller)
        defaultBmcUsername:
          type:
            - string
            - 'null'
          description: Username for accessing the Expected Switch's BMC
        defaultBmcPassword:
          type:
            - string
            - 'null'
          description: Password for accessing the Expected Switch's BMC
        switchSerialNumber:
          type: string
          description: Serial number of the Expected Switch
        nvOsUsername:
          type:
            - string
            - 'null'
          description: NvOS username for the Expected Switch
        nvOsPassword:
          type:
            - string
            - 'null'
          description: NvOS password for the Expected Switch
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Switches
      required:
        - siteId
        - bmcMacAddress
        - switchSerialNumber
      description: >-
        Request data to create a new Expected Switch.


        Note: BMC and NvOS credentials (username/password) are only accepted
        during creation and updates but are not returned in responses.
      title: ExpectedSwitchCreateRequest
    ExpectedSwitch:
      type: object
      properties:
        id:
          type: string
          format: uuid
          description: Unique identifier for the Expected Switch
        siteId:
          type: string
          format: uuid
          description: ID of the site the Expected Switch belongs to
        bmcMacAddress:
          type: string
          description: >-
            MAC address of the Expected Switch's BMC (Baseboard Management
            Controller)
        switchSerialNumber:
          type: string
          description: Serial number of the Expected Switch
        rackId:
          type:
            - string
            - 'null'
          description: Optional rack identifier for this component
        name:
          type:
            - string
            - 'null'
          description: Display name for this component
        manufacturer:
          type:
            - string
            - 'null'
          description: Manufacturer of this component
        model:
          type:
            - string
            - 'null'
          description: Model of this component
        description:
          type:
            - string
            - 'null'
          description: Description of this component
        firmwareVersion:
          type:
            - string
            - 'null'
          description: Firmware version of this component
        slotId:
          type:
            - integer
            - 'null'
          description: Slot ID within the rack
        trayIdx:
          type:
            - integer
            - 'null'
          description: Tray index within the rack
        hostId:
          type:
            - integer
            - 'null'
          description: Host ID within the tray
        labels:
          $ref: '#/components/schemas/Labels'
          description: >-
            User-defined key-value pairs for organizing and categorizing
            Expected Switches
        created:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Switch was created
        updated:
          type: string
          format: date-time
          description: ISO 8601 datetime when the Expected Switch was last updated
      description: >-
        An Expected Switch represents a network switch that is expected to be
        discovered at a site, with hardware identifiers and metadata.


        Note: BMC and NvOS credentials (username/password) are only accepted
        during creation and updates but are not returned in responses.
      title: ExpectedSwitch
    CarbideApiErrorSource:
      type: string
      enum:
        - carbide
      description: Source of the error. Only 'carbide' is supported
      title: CarbideApiErrorSource
    CarbideApiErrorData:
      type: object
      properties: {}
      description: Additional data about the error
      title: CarbideApiErrorData
    CarbideAPIError:
      type: object
      properties:
        source:
          $ref: '#/components/schemas/CarbideApiErrorSource'
          description: Source of the error. Only 'carbide' is supported
        message:
          type: string
          description: Message describing the error
        data:
          oneOf:
            - $ref: '#/components/schemas/CarbideApiErrorData'
            - type: 'null'
          description: Additional data about the error
      description: Describes the error response from NCX Infra Controller REST API
      title: CarbideAPIError
  securitySchemes:
    JWTBearerToken:
      type: http
      scheme: bearer
      description: >-
        ```

        export JWT_BEARER_TOKEN="<jwt-bearer-token>"


        # Example org name: "acme-inc

        export ORG_NAME=<org-name>


        # Use the JWT bearer token in your API request auth header:

        curl -v -X GET -H "Content-Type: application/json" -H "Authorization:
        Bearer $JWT_BEARER_TOKEN"
        https://carbide-rest-api.carbide.svc.cluster.local/v2/org/$ORG_NAME/carbide/user/current

        ```

```

## SDK Code Examples

```python
import requests

url = "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch"

payload = {
    "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
    "bmcMacAddress": "00:1A:2B:3C:4D:5E",
    "switchSerialNumber": "SWITCH-12345",
    "defaultBmcUsername": "admin",
    "defaultBmcPassword": "password123",
    "nvOsUsername": "nvadmin",
    "nvOsPassword": "nvpassword123",
    "labels": {
        "environment": "production",
        "rack": "A1"
    }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"siteId":"f97df110-f4de-492e-8849-4a6af68026b0","bmcMacAddress":"00:1A:2B:3C:4D:5E","switchSerialNumber":"SWITCH-12345","defaultBmcUsername":"admin","defaultBmcPassword":"password123","nvOsUsername":"nvadmin","nvOsPassword":"nvpassword123","labels":{"environment":"production","rack":"A1"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch"

	payload := strings.NewReader("{\n  \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n  \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n  \"switchSerialNumber\": \"SWITCH-12345\",\n  \"defaultBmcUsername\": \"admin\",\n  \"defaultBmcPassword\": \"password123\",\n  \"nvOsUsername\": \"nvadmin\",\n  \"nvOsPassword\": \"nvpassword123\",\n  \"labels\": {\n    \"environment\": \"production\",\n    \"rack\": \"A1\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n  \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n  \"switchSerialNumber\": \"SWITCH-12345\",\n  \"defaultBmcUsername\": \"admin\",\n  \"defaultBmcPassword\": \"password123\",\n  \"nvOsUsername\": \"nvadmin\",\n  \"nvOsPassword\": \"nvpassword123\",\n  \"labels\": {\n    \"environment\": \"production\",\n    \"rack\": \"A1\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n  \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n  \"switchSerialNumber\": \"SWITCH-12345\",\n  \"defaultBmcUsername\": \"admin\",\n  \"defaultBmcPassword\": \"password123\",\n  \"nvOsUsername\": \"nvadmin\",\n  \"nvOsPassword\": \"nvpassword123\",\n  \"labels\": {\n    \"environment\": \"production\",\n    \"rack\": \"A1\"\n  }\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch', [
  'body' => '{
  "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
  "bmcMacAddress": "00:1A:2B:3C:4D:5E",
  "switchSerialNumber": "SWITCH-12345",
  "defaultBmcUsername": "admin",
  "defaultBmcPassword": "password123",
  "nvOsUsername": "nvadmin",
  "nvOsPassword": "nvpassword123",
  "labels": {
    "environment": "production",
    "rack": "A1"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"siteId\": \"f97df110-f4de-492e-8849-4a6af68026b0\",\n  \"bmcMacAddress\": \"00:1A:2B:3C:4D:5E\",\n  \"switchSerialNumber\": \"SWITCH-12345\",\n  \"defaultBmcUsername\": \"admin\",\n  \"defaultBmcPassword\": \"password123\",\n  \"nvOsUsername\": \"nvadmin\",\n  \"nvOsPassword\": \"nvpassword123\",\n  \"labels\": {\n    \"environment\": \"production\",\n    \"rack\": \"A1\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "siteId": "f97df110-f4de-492e-8849-4a6af68026b0",
  "bmcMacAddress": "00:1A:2B:3C:4D:5E",
  "switchSerialNumber": "SWITCH-12345",
  "defaultBmcUsername": "admin",
  "defaultBmcPassword": "password123",
  "nvOsUsername": "nvadmin",
  "nvOsPassword": "nvpassword123",
  "labels": [
    "environment": "production",
    "rack": "A1"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://carbide-rest-api.carbide.svc.cluster.local/v2/org/org/carbide/expected-switch")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```